/*!  	
 * Copyright (c) 2014 ENEO Tecnología S.L.
 * This file is part of redBorder.
 * redBorder is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Affero General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * redBorder is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Affero General Public License for more details.
 * You should have received a copy of the GNU Affero General Public License
 * along with redBorder. If not, see <http://www.gnu.org/licenses/>.
 */

var reloadInterval;
var debounceTimer;

document.addEventListener('DOMContentLoaded', function() {
  if (!reloadInterval) {
    reloadInterval = setInterval(reloadTable, 10000);
  }

  setupSearchForm();
});

function reloadTable() {
    var currentPage = $("ul.pagination li.active a").html() || 1;
    var searchParams = $("#search_form_stored_job").serialize();
    var searchTerm = $("#search_form_stored_job input[name='search']").val();

    performSearch(searchParams, currentPage, searchTerm);
}

function performSearch(searchParams, currentPage, searchTerm) {
    $.ajax({
        url: '/jobs',
        method: 'GET',
        data: searchParams + '&page=' + currentPage,
        dataType: 'script',
        success: function() {
            $("#search_form_stored_job input[name='search']").val(searchTerm);
            updateSearchResults();
        },
        error: function() { console.error("Error al recargar la tabla"); }
    });
}

function updateSearchResults() {
    $('#stored-jobs-warning').html('');
    if ($('#stored-jobs-table tbody tr').length === 0) {
        var noResultsMessage = $('#stored-jobs-warning').data('no-results');
        $('#stored-jobs-warning').html('<div class="alert alert-warning">' + noResultsMessage + '</div>');
        $('#stored-jobs-table thead').hide();
    } else {
        $('#stored-jobs-table thead').show();
    }
}

function setupSearchForm() {
  $(document).on('keyup input', '#search_stored_job', function(e) {
    const searchInput = $(this);
    const searchForm = searchInput.closest('form');
    const searchParams = searchForm.serialize();
    const searchTerm = searchInput.val();
    const currentPage = $("ul.pagination li.active a").html() || 1;

    clearTimeout(debounceTimer);
    debounceTimer = setTimeout(function() {
        performSearch(searchParams, currentPage, searchTerm);
    }, 300);
  });

  $('#search_form_stored_job').on('ajax:success', function(event, data, status, xhr) {
    clearTimeout(debounceTimer);
    updateSearchResults();
  });

  $('#clear_search_stored_job').on('click', function() {
    $('#search_stored_job').val('');
    $('#stored-jobs-warning').html('');
    $('#search_form_stored_job').submit();
  });
}

function rule_db_version_status() {
	$.ajax({
		url: '/jobs/rule_db_version_status',
		global: false,
		dataType: 'script',
		cache: false,
		type: 'GET'
	})
}
